
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 24 "../../smtpd/parse.y"

#include "includes.h"

#include <sys/types.h>
#include <sys/time.h>
#include <sys/queue.h>
#include <sys/tree.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/ioctl.h>

#include <net/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <event.h>
#include <ifaddrs.h>
#include <imsg.h>
#include <inttypes.h>
#include <netdb.h>
#include <paths.h>
#include <pwd.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#ifdef HAVE_UTIL_H
#include <util.h>
#endif

#include <openssl/ssl.h>

#include "smtpd.h"
#include "ssl.h"
#include "log.h"

TAILQ_HEAD(files, file)		 files = TAILQ_HEAD_INITIALIZER(files);
static struct file {
	TAILQ_ENTRY(file)	 entry;
	FILE			*stream;
	char			*name;
	int			 lineno;
	int			 errors;
} *file, *topfile;
struct file	*pushfile(const char *, int);
int		 popfile(void);
int		 check_file_secrecy(int, const char *);
int		 yyparse(void);
int		 yylex(void);
int		 kw_cmp(const void *, const void *);
int		 lookup(char *);
int		 lgetc(int);
int		 lungetc(int);
int		 findeol(void);
int		 yyerror(const char *, ...)
    __attribute__ ((format (printf, 1, 2)));

TAILQ_HEAD(symhead, sym)	 symhead = TAILQ_HEAD_INITIALIZER(symhead);
struct sym {
	TAILQ_ENTRY(sym)	 entry;
	int			 used;
	int			 persist;
	char			*nam;
	char			*val;
};
int		 symset(const char *, const char *, int);
char		*symget(const char *);

struct smtpd		*conf = NULL;
static int		 errors = 0;

struct table		*table = NULL;
struct rule		*rule = NULL;
struct listener		 l;
struct mta_limits	*limits;
static struct ssl      	*pki_ssl;

static struct listen_opts {
	char	       *ifx;
	int		family;
	in_port_t	port;
	uint16_t	ssl;
	char	       *pki;
	uint16_t       	auth;
	char	        authtable[SMTPD_MAXLINESIZE];
	char	       *tag;
	char	       *hostname;
	struct table   *hostnametable;
	uint16_t	flags;	
} listen_opts;

static void	create_listener(struct listenerlist *,  struct listen_opts *);
static void	config_listener(struct listener *,  struct listen_opts *);

struct listener	*host_v4(const char *, in_port_t);
struct listener	*host_v6(const char *, in_port_t);
int		 host_dns(struct listenerlist *, struct listen_opts *);
int		 host(struct listenerlist *, struct listen_opts *);
int		 interface(struct listenerlist *, struct listen_opts *);
void		 set_localaddrs(void);
int		 delaytonum(char *);
int		 is_if_in_group(const char *, const char *);

typedef struct {
	union {
		int64_t		 number;
		struct table	*table;
		char		*string;
		struct host	*host;
		struct mailaddr	*maddr;
	} v;
	int lineno;
} YYSTYPE;



/* Line 189 of yacc.c  */
#line 195 "parse.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     AS = 258,
     QUEUE = 259,
     COMPRESSION = 260,
     ENCRYPTION = 261,
     MAXMESSAGESIZE = 262,
     MAXMTADEFERRED = 263,
     MAXSCHEDULERINFLIGHT = 264,
     LISTEN = 265,
     ON = 266,
     ANY = 267,
     PORT = 268,
     EXPIRE = 269,
     TABLE = 270,
     SECURE = 271,
     SMTPS = 272,
     CERTIFICATE = 273,
     DOMAIN = 274,
     BOUNCEWARN = 275,
     LIMIT = 276,
     INET4 = 277,
     INET6 = 278,
     RELAY = 279,
     BACKUP = 280,
     VIA = 281,
     DELIVER = 282,
     TO = 283,
     LMTP = 284,
     MAILDIR = 285,
     MBOX = 286,
     HOSTNAME = 287,
     HOSTNAMES = 288,
     ACCEPT = 289,
     REJECT = 290,
     INCLUDE = 291,
     ERROR = 292,
     MDA = 293,
     FROM = 294,
     FOR = 295,
     SOURCE = 296,
     MTA = 297,
     PKI = 298,
     ARROW = 299,
     AUTH = 300,
     TLS = 301,
     LOCAL = 302,
     VIRTUAL = 303,
     TAG = 304,
     TAGGED = 305,
     ALIAS = 306,
     FILTER = 307,
     KEY = 308,
     CA = 309,
     DHPARAMS = 310,
     AUTH_OPTIONAL = 311,
     TLS_REQUIRE = 312,
     USERBASE = 313,
     SENDER = 314,
     MASK_SOURCE = 315,
     VERIFY = 316,
     FORWARDONLY = 317,
     RECIPIENT = 318,
     STRING = 319,
     NUMBER = 320
   };
#endif
/* Tokens.  */
#define AS 258
#define QUEUE 259
#define COMPRESSION 260
#define ENCRYPTION 261
#define MAXMESSAGESIZE 262
#define MAXMTADEFERRED 263
#define MAXSCHEDULERINFLIGHT 264
#define LISTEN 265
#define ON 266
#define ANY 267
#define PORT 268
#define EXPIRE 269
#define TABLE 270
#define SECURE 271
#define SMTPS 272
#define CERTIFICATE 273
#define DOMAIN 274
#define BOUNCEWARN 275
#define LIMIT 276
#define INET4 277
#define INET6 278
#define RELAY 279
#define BACKUP 280
#define VIA 281
#define DELIVER 282
#define TO 283
#define LMTP 284
#define MAILDIR 285
#define MBOX 286
#define HOSTNAME 287
#define HOSTNAMES 288
#define ACCEPT 289
#define REJECT 290
#define INCLUDE 291
#define ERROR 292
#define MDA 293
#define FROM 294
#define FOR 295
#define SOURCE 296
#define MTA 297
#define PKI 298
#define ARROW 299
#define AUTH 300
#define TLS 301
#define LOCAL 302
#define VIRTUAL 303
#define TAG 304
#define TAGGED 305
#define ALIAS 306
#define FILTER 307
#define KEY 308
#define CA 309
#define DHPARAMS 310
#define AUTH_OPTIONAL 311
#define TLS_REQUIRE 312
#define USERBASE 313
#define SENDER 314
#define MASK_SOURCE 315
#define VERIFY 316
#define FORWARDONLY 317
#define RECIPIENT 318
#define STRING 319
#define NUMBER 320




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 366 "parse.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   194

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  74
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  64
/* YYNRULES -- Number of rules.  */
#define YYNRULES  157
/* YYNRULES -- Number of states.  */
#define YYNSTATES  241

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   320

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      66,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    73,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    68,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      71,    67,    72,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    69,     2,    70,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,    11,    15,    19,    23,    27,
      31,    34,    38,    40,    42,    43,    46,    47,    50,    52,
      54,    58,    60,    64,    66,    67,    69,    71,    74,    77,
      78,    81,    84,    87,    90,    93,    94,    96,    98,   101,
     104,   106,   109,   111,   113,   115,   118,   121,   123,   125,
     128,   131,   134,   137,   140,   142,   145,   146,   149,   152,
     155,   158,   161,   163,   165,   168,   171,   174,   175,   178,
     180,   183,   186,   187,   188,   192,   195,   198,   203,   206,
     209,   212,   215,   216,   224,   225,   230,   231,   237,   240,
     244,   245,   250,   254,   255,   262,   264,   266,   270,   272,
     276,   278,   280,   284,   286,   288,   290,   291,   296,   300,
     302,   304,   307,   310,   312,   314,   317,   321,   326,   331,
     335,   340,   343,   344,   350,   352,   353,   358,   362,   366,
     371,   375,   379,   383,   387,   389,   392,   394,   396,   398,
     400,   402,   405,   406,   408,   410,   413,   414,   416,   418,
     419,   421,   423,   426,   427,   428,   435,   436
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      75,     0,    -1,    -1,    75,    66,    -1,    75,    76,    66,
      -1,    75,    77,    66,    -1,    75,    96,    66,    -1,    75,
     102,    66,    -1,    75,   135,    66,    -1,    75,     1,    66,
      -1,    36,    64,    -1,    64,    67,    64,    -1,    68,    -1,
      80,    -1,    -1,    66,    79,    -1,    -1,    66,    79,    -1,
      65,    -1,    64,    -1,    50,   121,    64,    -1,    64,    -1,
      84,    68,    83,    -1,    83,    -1,    -1,    22,    -1,    23,
      -1,    64,    65,    -1,    85,    86,    -1,    -1,    18,    64,
      -1,    53,    64,    -1,    54,    64,    -1,    55,    64,    -1,
      87,    88,    -1,    -1,    22,    -1,    23,    -1,    13,    64,
      -1,    13,    65,    -1,    17,    -1,    17,    61,    -1,    46,
      -1,    16,    -1,    57,    -1,    57,    61,    -1,    43,    64,
      -1,    45,    -1,    56,    -1,    45,   113,    -1,    56,   113,
      -1,    49,    64,    -1,    32,    64,    -1,    33,   113,    -1,
      60,    -1,    89,    90,    -1,    -1,     3,    64,    -1,    41,
     113,    -1,    33,   113,    -1,    43,    64,    -1,    25,    64,
      -1,    25,    -1,    46,    -1,    46,    61,    -1,    91,    93,
      -1,    92,    93,    -1,    -1,    45,   113,    -1,    61,    -1,
      91,    95,    -1,    94,    95,    -1,    -1,    -1,    20,    97,
      84,    -1,     4,     5,    -1,     4,     6,    -1,     4,     6,
      53,    64,    -1,    14,    64,    -1,     7,    81,    -1,     8,
      65,    -1,     9,    65,    -1,    -1,    21,    42,    40,    19,
      64,    98,    86,    -1,    -1,    21,    42,    99,    86,    -1,
      -1,    10,   100,    11,    64,    90,    -1,    52,    64,    -1,
      52,    64,    64,    -1,    -1,    43,    64,   101,    88,    -1,
      15,    64,    64,    -1,    -1,    15,    64,   103,    69,   109,
      70,    -1,    67,    -1,    44,    -1,    64,   104,    64,    -1,
     105,    -1,   105,    78,   106,    -1,    64,    -1,   107,    -1,
     107,    78,   108,    -1,   108,    -1,   106,    -1,    64,    -1,
      -1,    69,   111,   109,    70,    -1,    71,    64,    72,    -1,
     110,    -1,   112,    -1,    51,   113,    -1,    48,   113,    -1,
     114,    -1,   115,    -1,    58,   113,    -1,    27,    28,    30,
      -1,    27,    28,    30,    64,    -1,    27,    28,    29,    64,
      -1,    27,    28,    31,    -1,    27,    28,    38,    64,    -1,
      24,    93,    -1,    -1,    24,    26,    64,   120,    95,    -1,
      73,    -1,    -1,    39,   121,    41,   113,    -1,    39,   121,
      12,    -1,    39,   121,    47,    -1,    40,   121,    19,   113,
      -1,    40,   121,    12,    -1,    40,   121,    47,    -1,    59,
     121,   113,    -1,    63,   121,   113,    -1,    62,    -1,    14,
      64,    -1,   124,    -1,   125,    -1,   122,    -1,   123,    -1,
      82,    -1,   128,   129,    -1,    -1,   117,    -1,   116,    -1,
     130,   131,    -1,    -1,   118,    -1,   119,    -1,    -1,   127,
      -1,   126,    -1,   133,   134,    -1,    -1,    -1,    34,   136,
     129,   131,   132,   134,    -1,    -1,    35,   137,   129,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   159,   159,   160,   161,   162,   163,   164,   165,   166,
     169,   184,   192,   193,   194,   197,   198,   201,   204,   211,
     224,   236,   255,   256,   257,   260,   263,   266,   276,   277,
     280,   283,   286,   289,   294,   295,   298,   299,   300,   312,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     332,   336,   344,   345,   354,   357,   358,   361,   386,   396,
     406,   415,   420,   426,   429,   434,   435,   436,   439,   450,
     459,   460,   461,   464,   464,   467,   470,   487,   510,   519,
     522,   525,   528,   528,   540,   540,   543,   543,   551,   578,
     608,   608,   619,   656,   656,   664,   664,   666,   674,   675,
     678,   685,   686,   689,   690,   693,   702,   702,   709,   722,
     723,   726,   739,   751,   759,   769,   785,   792,   800,   811,
     818,   828,   831,   831,   850,   851,   854,   869,   877,   887,
     902,   910,   920,   938,   956,   965,   980,   981,   982,   983,
     984,   986,   987,   990,   991,   993,   994,   997,   998,   999,
    1002,  1003,  1006,  1007,  1010,  1010,  1042,  1042
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "AS", "QUEUE", "COMPRESSION",
  "ENCRYPTION", "MAXMESSAGESIZE", "MAXMTADEFERRED", "MAXSCHEDULERINFLIGHT",
  "LISTEN", "ON", "ANY", "PORT", "EXPIRE", "TABLE", "SECURE", "SMTPS",
  "CERTIFICATE", "DOMAIN", "BOUNCEWARN", "LIMIT", "INET4", "INET6",
  "RELAY", "BACKUP", "VIA", "DELIVER", "TO", "LMTP", "MAILDIR", "MBOX",
  "HOSTNAME", "HOSTNAMES", "ACCEPT", "REJECT", "INCLUDE", "ERROR", "MDA",
  "FROM", "FOR", "SOURCE", "MTA", "PKI", "ARROW", "AUTH", "TLS", "LOCAL",
  "VIRTUAL", "TAG", "TAGGED", "ALIAS", "FILTER", "KEY", "CA", "DHPARAMS",
  "AUTH_OPTIONAL", "TLS_REQUIRE", "USERBASE", "SENDER", "MASK_SOURCE",
  "VERIFY", "FORWARDONLY", "RECIPIENT", "STRING", "NUMBER", "'\\n'", "'='",
  "','", "'{'", "'}'", "'<'", "'>'", "'!'", "$accept", "grammar",
  "include", "varset", "comma", "optnl", "nl", "size", "tagged",
  "bouncedelay", "bouncedelays", "opt_limit", "limits", "opt_pki", "pki",
  "opt_listen", "listen", "opt_relay_common", "opt_relay", "relay",
  "opt_relay_via", "relay_via", "main", "$@1", "$@2", "$@3", "$@4", "$@5",
  "table", "$@6", "assign", "keyval", "keyval_list", "stringel",
  "string_list", "tableval_list", "tablenew", "$@7", "tableref", "tables",
  "alias", "virtual", "usermapping", "userbase", "deliver_action",
  "relay_action", "$@8", "negation", "from", "for", "sender", "recipient",
  "forwardonly", "expire", "opt_decision", "decision", "opt_lookup",
  "lookup", "action", "opt_accept", "accept_params", "rule", "$@9", "$@10", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,    10,    61,    44,   123,
     125,    60,    62,    33
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    74,    75,    75,    75,    75,    75,    75,    75,    75,
      76,    77,    78,    78,    78,    79,    79,    80,    81,    81,
      82,    83,    84,    84,    84,    85,    85,    85,    86,    86,
      87,    87,    87,    87,    88,    88,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    90,    90,    91,    91,    91,
      91,    92,    92,    92,    92,    93,    93,    93,    94,    94,
      95,    95,    95,    97,    96,    96,    96,    96,    96,    96,
      96,    96,    98,    96,    99,    96,   100,    96,    96,    96,
     101,    96,   102,   103,   102,   104,   104,   105,   106,   106,
     107,   108,   108,   109,   109,   110,   111,   110,   112,   113,
     113,   114,   115,   116,   116,   117,   118,   118,   118,   118,
     118,   119,   120,   119,   121,   121,   122,   122,   122,   123,
     123,   123,   124,   125,   126,   127,   128,   128,   128,   128,
     128,   129,   129,   130,   130,   131,   131,   132,   132,   132,
     133,   133,   134,   134,   136,   135,   137,   135
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     3,     3,     3,     3,     3,     3,
       2,     3,     1,     1,     0,     2,     0,     2,     1,     1,
       3,     1,     3,     1,     0,     1,     1,     2,     2,     0,
       2,     2,     2,     2,     2,     0,     1,     1,     2,     2,
       1,     2,     1,     1,     1,     2,     2,     1,     1,     2,
       2,     2,     2,     2,     1,     2,     0,     2,     2,     2,
       2,     2,     1,     1,     2,     2,     2,     0,     2,     1,
       2,     2,     0,     0,     3,     2,     2,     4,     2,     2,
       2,     2,     0,     7,     0,     4,     0,     5,     2,     3,
       0,     4,     3,     0,     6,     1,     1,     3,     1,     3,
       1,     1,     3,     1,     1,     1,     0,     4,     3,     1,
       1,     2,     2,     1,     1,     2,     3,     4,     4,     3,
       4,     2,     0,     5,     1,     0,     4,     3,     3,     4,
       3,     3,     3,     3,     1,     2,     1,     1,     1,     1,
       1,     2,     0,     1,     1,     2,     0,     1,     1,     0,
       1,     1,     2,     0,     0,     6,     0,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,     0,     0,     0,     0,     0,    86,     0,
       0,    73,     0,   154,   156,     0,     0,     0,     0,     3,
       0,     0,     0,     0,     0,     9,    75,    76,    19,    18,
      79,    80,    81,     0,    78,    93,    24,    84,   142,   142,
      10,    90,    88,     0,     4,     5,     6,     7,     8,     0,
       0,    92,     0,    21,    23,    74,     0,    29,   125,   125,
     125,   125,   125,   140,   138,   139,   136,   137,   142,   146,
     157,    35,    89,    11,    77,    56,     0,     0,     0,    25,
      26,     0,    29,    85,   124,     0,     0,     0,     0,     0,
     141,     0,     0,     0,   113,   114,   144,   143,   146,   149,
       0,     0,     0,     0,    35,    91,     0,    43,    40,    36,
      37,     0,     0,     0,    47,    42,     0,    48,    44,    54,
      56,    87,   100,    14,   104,    14,   103,     0,    22,    82,
      27,    28,   127,     0,   128,   130,     0,   131,    20,   105,
     106,     0,   109,   110,   132,   133,   112,   111,   115,   145,
      67,     0,   147,   148,   153,    30,    31,    32,    33,    34,
      38,    39,    41,    52,    53,    46,    49,    51,    50,    45,
      55,    96,    95,     0,    16,    12,     0,    13,     0,    94,
      29,   126,   129,     0,     0,     0,    62,     0,     0,     0,
       0,    63,    67,    67,   121,     0,     0,   134,   151,   150,
     153,   155,    97,    16,    17,     0,    99,   100,   102,    83,
       0,   108,    57,    61,   122,    59,    58,    60,    64,    65,
      66,     0,   116,   119,     0,   135,   152,    15,   107,    72,
     118,   117,   120,     0,    69,    72,    72,   123,    68,    70,
      71
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    20,    21,   176,   204,   177,    30,    63,    54,
      55,    82,    83,   104,   105,   120,   121,   192,   193,   194,
     236,   237,    22,    36,   180,    57,    33,    71,    23,    52,
     173,   123,   124,   125,   126,   127,   142,   183,   143,   144,
      94,    95,    96,    97,   152,   153,   229,    85,    64,    65,
      66,    67,   198,   199,    68,    69,    98,    99,   154,   200,
     201,    24,    38,    39
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -119
static const yytype_int16 yypact[] =
{
    -119,     6,  -119,   -49,    13,    17,   -13,    -3,  -119,    -4,
      19,  -119,    35,  -119,  -119,    60,    64,    68,    55,  -119,
      67,    69,    70,    71,    72,  -119,  -119,    81,  -119,  -119,
    -119,  -119,  -119,   128,  -119,    76,    77,   102,    66,    66,
    -119,  -119,    79,    82,  -119,  -119,  -119,  -119,  -119,    83,
      84,  -119,    80,  -119,  -119,    85,   126,   -11,    78,    78,
      78,    78,    78,  -119,  -119,  -119,  -119,  -119,    66,    62,
    -119,    25,  -119,  -119,  -119,    52,    86,    77,    88,  -119,
    -119,    89,   -11,  -119,  -119,    20,    12,    91,   -35,   -35,
    -119,   -35,   -35,   -35,  -119,  -119,  -119,  -119,    62,    27,
      92,    93,    94,    95,    25,  -119,    50,  -119,    99,  -119,
    -119,    97,   -35,    98,   -35,  -119,   100,   -35,   104,  -119,
      52,  -119,   -22,   -31,  -119,    53,  -119,    96,  -119,  -119,
    -119,  -119,  -119,   -35,  -119,  -119,   -35,  -119,  -119,  -119,
    -119,   103,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
      30,   135,  -119,  -119,    -5,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,  -119,   105,   106,  -119,   107,  -119,   109,  -119,
     -11,  -119,  -119,    86,   108,   110,   111,   112,   -35,   -35,
     113,   117,    61,    61,  -119,    58,   115,  -119,  -119,  -119,
      -5,  -119,  -119,   106,  -119,   -22,  -119,  -119,  -119,  -119,
     114,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,   118,   119,  -119,   121,  -119,  -119,  -119,  -119,     5,
    -119,  -119,  -119,   -35,  -119,     5,     5,  -119,  -119,  -119,
    -119
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
    -119,  -119,  -119,  -119,    43,   -33,  -119,  -119,  -119,   116,
    -119,  -119,   -77,  -119,    87,  -119,    74,  -118,  -119,   -66,
    -119,  -105,  -119,  -119,  -119,  -119,  -119,  -119,  -119,  -119,
    -119,  -119,    10,  -119,     3,     4,  -119,  -119,  -119,   -89,
    -119,  -119,  -119,  -119,  -119,  -119,  -119,    31,  -119,  -119,
    -119,  -119,  -119,  -119,  -119,   -38,  -119,    90,  -119,  -119,
     -10,  -119,  -119,  -119
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -102
static const yytype_int16 yytable[] =
{
     145,    70,   146,   147,   148,   131,     2,     3,   185,   196,
       4,    79,    80,     5,     6,     7,     8,    25,    26,    27,
       9,    10,   171,   164,   135,   166,    11,    12,   168,   139,
      90,   136,   132,   185,   140,   174,   141,   175,   188,   -98,
      13,    14,    15,   100,   181,   172,   189,   182,   190,    16,
     233,   150,    31,    81,   151,   186,   187,   197,    17,   137,
      34,   133,    32,   188,   185,   106,   234,   134,   107,   108,
      18,   189,    19,   190,   109,   110,   191,    37,   101,   102,
     103,    28,    29,    35,   111,   112,   186,   221,   222,   223,
      86,    87,    88,    89,   188,   113,   224,   114,   115,   215,
     216,   116,   189,   209,   190,    58,    59,   191,   117,   118,
      91,   235,   119,    92,   160,   161,    60,   235,   235,   174,
      93,   175,    43,  -101,    40,    61,   219,   220,    41,    62,
     239,   240,    42,    44,    49,    45,    46,    47,    48,    50,
      51,    53,    56,    72,   238,    78,    73,    74,    75,    76,
     122,    84,   129,    77,   130,   138,   155,   156,   157,   158,
     162,   163,   165,   195,   167,   169,   179,   184,   178,   202,
     227,   205,   203,   207,   212,   213,   214,   217,   218,   225,
     211,   208,   230,   231,   228,   232,   206,   210,   149,     0,
     226,   159,     0,   128,   170
};

static const yytype_int16 yycheck[] =
{
      89,    39,    91,    92,    93,    82,     0,     1,     3,    14,
       4,    22,    23,     7,     8,     9,    10,    66,     5,     6,
      14,    15,    44,   112,    12,   114,    20,    21,   117,    64,
      68,    19,    12,     3,    69,    66,    71,    68,    33,    70,
      34,    35,    36,    18,   133,    67,    41,   136,    43,    43,
      45,    24,    65,    64,    27,    25,    26,    62,    52,    47,
      64,    41,    65,    33,     3,    13,    61,    47,    16,    17,
      64,    41,    66,    43,    22,    23,    46,    42,    53,    54,
      55,    64,    65,    64,    32,    33,    25,    29,    30,    31,
      59,    60,    61,    62,    33,    43,    38,    45,    46,   188,
     189,    49,    41,   180,    43,    39,    40,    46,    56,    57,
      48,   229,    60,    51,    64,    65,    50,   235,   236,    66,
      58,    68,    67,    70,    64,    59,   192,   193,    64,    63,
     235,   236,    64,    66,    53,    66,    66,    66,    66,    11,
      64,    64,    40,    64,   233,    19,    64,    64,    64,    69,
      64,    73,    64,    68,    65,    64,    64,    64,    64,    64,
      61,    64,    64,    28,    64,    61,    70,    64,   125,    64,
     203,    64,    66,    64,    64,    64,    64,    64,    61,    64,
      72,   178,    64,    64,    70,    64,   176,   183,    98,    -1,
     200,   104,    -1,    77,   120
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    75,     0,     1,     4,     7,     8,     9,    10,    14,
      15,    20,    21,    34,    35,    36,    43,    52,    64,    66,
      76,    77,    96,   102,   135,    66,     5,     6,    64,    65,
      81,    65,    65,   100,    64,    64,    97,    42,   136,   137,
      64,    64,    64,    67,    66,    66,    66,    66,    66,    53,
      11,    64,   103,    64,    83,    84,    40,    99,    39,    40,
      50,    59,    63,    82,   122,   123,   124,   125,   128,   129,
     129,   101,    64,    64,    64,    64,    69,    68,    19,    22,
      23,    64,    85,    86,    73,   121,   121,   121,   121,   121,
     129,    48,    51,    58,   114,   115,   116,   117,   130,   131,
      18,    53,    54,    55,    87,    88,    13,    16,    17,    22,
      23,    32,    33,    43,    45,    46,    49,    56,    57,    60,
      89,    90,    64,   105,   106,   107,   108,   109,    83,    64,
      65,    86,    12,    41,    47,    12,    19,    47,    64,    64,
      69,    71,   110,   112,   113,   113,   113,   113,   113,   131,
      24,    27,   118,   119,   132,    64,    64,    64,    64,    88,
      64,    65,    61,    64,   113,    64,   113,    64,   113,    61,
      90,    44,    67,   104,    66,    68,    78,    80,    78,    70,
      98,   113,   113,   111,    64,     3,    25,    26,    33,    41,
      43,    46,    91,    92,    93,    28,    14,    62,   126,   127,
     133,   134,    64,    66,    79,    64,   106,    64,   108,    86,
     109,    72,    64,    64,    64,   113,   113,    64,    61,    93,
      93,    29,    30,    31,    38,    64,   134,    79,    70,   120,
      64,    64,    64,    45,    61,    91,    94,    95,   113,    95,
      95
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 9:

/* Line 1455 of yacc.c  */
#line 166 "../../smtpd/parse.y"
    { file->errors++; }
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 169 "../../smtpd/parse.y"
    {
			struct file	*nfile;

			if ((nfile = pushfile((yyvsp[(2) - (2)].v.string), 0)) == NULL) {
				yyerror("failed to include file %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));

			file = nfile;
			lungetc('\n');
		}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 184 "../../smtpd/parse.y"
    {
			if (symset((yyvsp[(1) - (3)].v.string), (yyvsp[(3) - (3)].v.string), 0) == -1)
				fatal("cannot store variable");
			free((yyvsp[(1) - (3)].v.string));
			free((yyvsp[(3) - (3)].v.string));
		}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 204 "../../smtpd/parse.y"
    {
			if ((yyvsp[(1) - (1)].v.number) < 0) {
				yyerror("invalid size: %" PRId64, (yyvsp[(1) - (1)].v.number));
				YYERROR;
			}
			(yyval.v.number) = (yyvsp[(1) - (1)].v.number);
		}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 211 "../../smtpd/parse.y"
    {
			long long result;

			if (scan_scaled((yyvsp[(1) - (1)].v.string), &result) == -1 || result < 0) {
				yyerror("invalid size: %s", (yyvsp[(1) - (1)].v.string));
				free((yyvsp[(1) - (1)].v.string));
				YYERROR;
			}
			free((yyvsp[(1) - (1)].v.string));
			(yyval.v.number) = result;
		}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 224 "../../smtpd/parse.y"
    {
			if (strlcpy(rule->r_tag, (yyvsp[(3) - (3)].v.string), sizeof rule->r_tag)
			    >= sizeof rule->r_tag) {
				yyerror("tag name too long: %s", (yyvsp[(3) - (3)].v.string));
				free((yyvsp[(3) - (3)].v.string));
				YYERROR;
			}
			free((yyvsp[(3) - (3)].v.string));
			rule->r_nottag = (yyvsp[(2) - (3)].v.number);
		}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 236 "../../smtpd/parse.y"
    {
			time_t	d;
			int	i;

			d = delaytonum((yyvsp[(1) - (1)].v.string));
			if (d < 0) {
				yyerror("invalid bounce delay: %s", (yyvsp[(1) - (1)].v.string));
				free((yyvsp[(1) - (1)].v.string));
				YYERROR;
			}
			free((yyvsp[(1) - (1)].v.string));
			for (i = 0; i < MAX_BOUNCE_WARN; i++) {
				if (conf->sc_bounce_warn[i] != 0)
					continue;
				conf->sc_bounce_warn[i] = d;
				break;
			}
		}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 260 "../../smtpd/parse.y"
    {
			limits->family = AF_INET;
		}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 263 "../../smtpd/parse.y"
    {
			limits->family = AF_INET6;
		}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 266 "../../smtpd/parse.y"
    {
			if (!limit_mta_set(limits, (yyvsp[(1) - (2)].v.string), (yyvsp[(2) - (2)].v.number))) {
				yyerror("invalid limit keyword");
				free((yyvsp[(1) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(1) - (2)].v.string));
		}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 280 "../../smtpd/parse.y"
    {
			pki_ssl->ssl_cert_file = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 283 "../../smtpd/parse.y"
    {
			pki_ssl->ssl_key_file = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 286 "../../smtpd/parse.y"
    {
			pki_ssl->ssl_ca_file = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 289 "../../smtpd/parse.y"
    {
			pki_ssl->ssl_dhparams_file = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 298 "../../smtpd/parse.y"
    { listen_opts.family = AF_INET; }
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 299 "../../smtpd/parse.y"
    { listen_opts.family = AF_INET6; }
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 300 "../../smtpd/parse.y"
    {
			struct servent	*servent;

			servent = getservbyname((yyvsp[(2) - (2)].v.string), "tcp");
			if (servent == NULL) {
				yyerror("invalid port: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
			listen_opts.port = ntohs(servent->s_port);
		}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 312 "../../smtpd/parse.y"
    {
			if ((yyvsp[(2) - (2)].v.number) <= 0 || (yyvsp[(2) - (2)].v.number) >= (int)USHRT_MAX) {
				yyerror("invalid port: %" PRId64, (yyvsp[(2) - (2)].v.number));
				YYERROR;
			}
			listen_opts.port = (yyvsp[(2) - (2)].v.number);
		}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 319 "../../smtpd/parse.y"
    { listen_opts.ssl = F_SMTPS; }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 320 "../../smtpd/parse.y"
    { listen_opts.ssl = F_SMTPS|F_TLS_VERIFY; }
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 321 "../../smtpd/parse.y"
    { listen_opts.ssl = F_STARTTLS; }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 322 "../../smtpd/parse.y"
    { listen_opts.ssl = F_SSL; }
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 323 "../../smtpd/parse.y"
    { listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE; }
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 324 "../../smtpd/parse.y"
    { listen_opts.ssl = F_STARTTLS|F_STARTTLS_REQUIRE|F_TLS_VERIFY; }
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 325 "../../smtpd/parse.y"
    { listen_opts.pki = (yyvsp[(2) - (2)].v.string); }
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 326 "../../smtpd/parse.y"
    { listen_opts.auth = F_AUTH|F_AUTH_REQUIRE; }
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 327 "../../smtpd/parse.y"
    { listen_opts.auth = F_AUTH; }
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 328 "../../smtpd/parse.y"
    {
			strlcpy(listen_opts.authtable, ((yyvsp[(2) - (2)].v.table))->t_name, sizeof listen_opts.authtable);
			listen_opts.auth = F_AUTH|F_AUTH_REQUIRE;
		}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 332 "../../smtpd/parse.y"
    {
			strlcpy(listen_opts.authtable, ((yyvsp[(2) - (2)].v.table))->t_name, sizeof listen_opts.authtable);
			listen_opts.auth = F_AUTH;
		}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 336 "../../smtpd/parse.y"
    {
       			if (strlen((yyvsp[(2) - (2)].v.string)) >= MAX_TAG_SIZE) {
       				yyerror("tag name too long");
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			listen_opts.tag = (yyvsp[(2) - (2)].v.string);
		}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 344 "../../smtpd/parse.y"
    { listen_opts.hostname = (yyvsp[(2) - (2)].v.string); }
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 345 "../../smtpd/parse.y"
    {
			struct table	*t = (yyvsp[(2) - (2)].v.table);
			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
				yyerror("invalid use of table \"%s\" as "
				    "HOSTNAMES parameter", t->t_name);
				YYERROR;
			}
			listen_opts.hostnametable = t;
		}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 354 "../../smtpd/parse.y"
    { listen_opts.flags |= F_MASK_SOURCE; }
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 361 "../../smtpd/parse.y"
    {
			struct mailaddr maddr, *maddrp;

			if (! text_to_mailaddr(&maddr, (yyvsp[(2) - (2)].v.string))) {
				yyerror("invalid parameter to AS: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));

			if (maddr.user[0] == '\0' && maddr.domain[0] == '\0') {
				yyerror("invalid empty parameter to AS");
				YYERROR;
			}
			else if (maddr.domain[0] == '\0') {
				if (strlcpy(maddr.domain, conf->sc_hostname,
					sizeof (maddr.domain))
				    >= sizeof (maddr.domain)) {
					yyerror("hostname too long for AS parameter: %s",
					    conf->sc_hostname);
					YYERROR;
				}
			}
			rule->r_as = xmemdup(&maddr, sizeof (*maddrp), "parse relay_as: AS");
		}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 386 "../../smtpd/parse.y"
    {
			struct table	*t = (yyvsp[(2) - (2)].v.table);
			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_SOURCE)) {
				yyerror("invalid use of table \"%s\" as "
				    "SOURCE parameter", t->t_name);
				YYERROR;
			}
			strlcpy(rule->r_value.relayhost.sourcetable, t->t_name,
			    sizeof rule->r_value.relayhost.sourcetable);
		}
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 396 "../../smtpd/parse.y"
    {
			struct table	*t = (yyvsp[(2) - (2)].v.table);
			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_ADDRNAME)) {
				yyerror("invalid use of table \"%s\" as "
				    "HOSTNAMES parameter", t->t_name);
				YYERROR;
			}
			strlcpy(rule->r_value.relayhost.helotable, t->t_name,
			    sizeof rule->r_value.relayhost.helotable);
		}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 406 "../../smtpd/parse.y"
    {
			if (strlcpy(rule->r_value.relayhost.cert, (yyvsp[(2) - (2)].v.string),
				sizeof(rule->r_value.relayhost.cert))
			    >= sizeof(rule->r_value.relayhost.cert))
				fatal("certificate path too long");
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 415 "../../smtpd/parse.y"
    {
			rule->r_value.relayhost.flags |= F_BACKUP;
			strlcpy(rule->r_value.relayhost.hostname, (yyvsp[(2) - (2)].v.string),
			    sizeof (rule->r_value.relayhost.hostname));
		}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 420 "../../smtpd/parse.y"
    {
			rule->r_value.relayhost.flags |= F_BACKUP;
			strlcpy(rule->r_value.relayhost.hostname,
			    conf->sc_hostname,
			    sizeof (rule->r_value.relayhost.hostname));
		}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 426 "../../smtpd/parse.y"
    {
			rule->r_value.relayhost.flags |= F_STARTTLS;
		}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 429 "../../smtpd/parse.y"
    {
			rule->r_value.relayhost.flags |= F_STARTTLS|F_TLS_VERIFY;
		}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 439 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(2) - (2)].v.table);

			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_CREDENTIALS)) {
				yyerror("invalid use of table \"%s\" as AUTH parameter",
				    t->t_name);
				YYERROR;
			}
			strlcpy(rule->r_value.relayhost.authtable, t->t_name,
			    sizeof(rule->r_value.relayhost.authtable));
		}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 450 "../../smtpd/parse.y"
    {
			if (!(rule->r_value.relayhost.flags & F_SSL)) {
				yyerror("cannot \"verify\" with insecure protocol");
				YYERROR;
			}
			rule->r_value.relayhost.flags |= F_TLS_VERIFY;
		}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 464 "../../smtpd/parse.y"
    {
			bzero(conf->sc_bounce_warn, sizeof conf->sc_bounce_warn);
		}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 467 "../../smtpd/parse.y"
    {
			conf->sc_queue_flags |= QUEUE_COMPRESSION;
		}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 470 "../../smtpd/parse.y"
    {
			char	*password;

			password = getpass("queue key: ");
			if (password == NULL) {
				yyerror("getpass() error");
				YYERROR;
			}
			conf->sc_queue_key = strdup(password);
			bzero(password, strlen(password));
			if (conf->sc_queue_key == NULL) {
				yyerror("memory exhausted");
				YYERROR;
			}
			conf->sc_queue_flags |= QUEUE_ENCRYPTION;

		}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 487 "../../smtpd/parse.y"
    {
			char   *buf;
			char   *lbuf;
			size_t	len;

			if (strcasecmp((yyvsp[(4) - (4)].v.string), "stdin") == 0 ||
			    strcasecmp((yyvsp[(4) - (4)].v.string), "-") == 0) {
				lbuf = NULL;
				buf = fgetln(stdin, &len);
				if (buf[len - 1] == '\n') {
					lbuf = calloc(len, 1);
					memcpy(lbuf, buf, len-1);
				}
				else {
					lbuf = calloc(len+1, 1);
					memcpy(lbuf, buf, len);
				}
				conf->sc_queue_key = lbuf;
			}
			else
				conf->sc_queue_key = (yyvsp[(4) - (4)].v.string);
			conf->sc_queue_flags |= QUEUE_ENCRYPTION;
		}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 510 "../../smtpd/parse.y"
    {
			conf->sc_qexpire = delaytonum((yyvsp[(2) - (2)].v.string));
			if (conf->sc_qexpire == -1) {
				yyerror("invalid expire delay: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 519 "../../smtpd/parse.y"
    {
			conf->sc_maxsize = (yyvsp[(2) - (2)].v.number);
		}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 522 "../../smtpd/parse.y"
    {
			conf->sc_mta_max_deferred = (yyvsp[(2) - (2)].v.number);
		}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 525 "../../smtpd/parse.y"
    {
			conf->sc_scheduler_max_inflight = (yyvsp[(2) - (2)].v.number);
		}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 528 "../../smtpd/parse.y"
    {
			struct mta_limits	*d;

			limits = dict_get(conf->sc_limits_dict, (yyvsp[(5) - (5)].v.string));
			if (limits == NULL) {
				limits = xcalloc(1, sizeof(*limits), "mta_limits");
				dict_xset(conf->sc_limits_dict, (yyvsp[(5) - (5)].v.string), limits);
				d = dict_xget(conf->sc_limits_dict, "default");
				memmove(limits, d, sizeof(*limits));
			}
			free((yyvsp[(5) - (5)].v.string));
		}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 540 "../../smtpd/parse.y"
    {
			limits = dict_get(conf->sc_limits_dict, "default");
		}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 543 "../../smtpd/parse.y"
    {
			bzero(&l, sizeof l);
			bzero(&listen_opts, sizeof listen_opts);
			listen_opts.family = AF_UNSPEC;
		}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 547 "../../smtpd/parse.y"
    {
			listen_opts.ifx = (yyvsp[(4) - (5)].v.string);
			create_listener(conf->sc_listeners, &listen_opts);
		}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 551 "../../smtpd/parse.y"
    {
			struct filter *filter;
			struct filter *tmp;

			filter = xcalloc(1, sizeof *filter, "parse condition: FILTER");
			if (strlcpy(filter->name, (yyvsp[(2) - (2)].v.string), sizeof (filter->name))
			    >= sizeof (filter->name)) {
       				yyerror("Filter name too long: %s", filter->name);
				free((yyvsp[(2) - (2)].v.string));
				free(filter);
				YYERROR;
				
			}
			(void)snprintf(filter->path, sizeof filter->path,
			    PATH_FILTERS "/%s", filter->name);

			tmp = dict_get(&conf->sc_filters, filter->name);
			if (tmp == NULL)
				dict_set(&conf->sc_filters, filter->name, filter);
			else {
       				yyerror("ambiguous filter name: %s", filter->name);
				free((yyvsp[(2) - (2)].v.string));
				free(filter);
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 578 "../../smtpd/parse.y"
    {
			struct filter *filter;
			struct filter *tmp;

			filter = calloc(1, sizeof (*filter));
			if (filter == NULL ||
			    strlcpy(filter->name, (yyvsp[(2) - (3)].v.string), sizeof (filter->name))
			    >= sizeof (filter->name) ||
			    strlcpy(filter->path, (yyvsp[(3) - (3)].v.string), sizeof (filter->path))
			    >= sizeof (filter->path)) {
				free(filter);
				free((yyvsp[(2) - (3)].v.string));
				free((yyvsp[(3) - (3)].v.string));
				free(filter);
				YYERROR;
			}

			tmp = dict_get(&conf->sc_filters, filter->name);
			if (tmp == NULL)
				dict_set(&conf->sc_filters, filter->name, filter);
			else {
       				yyerror("ambiguous filter name: %s", filter->name);
				free((yyvsp[(2) - (3)].v.string));
				free((yyvsp[(3) - (3)].v.string));
				free(filter);
				YYERROR;
			}
			free((yyvsp[(2) - (3)].v.string));
			free((yyvsp[(3) - (3)].v.string));
		}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 608 "../../smtpd/parse.y"
    {
			pki_ssl = dict_get(conf->sc_ssl_dict, (yyvsp[(2) - (2)].v.string));
			if (pki_ssl == NULL) {
				pki_ssl = xcalloc(1, sizeof *pki_ssl, "parse:pki");
				xlowercase(pki_ssl->ssl_name, (yyvsp[(2) - (2)].v.string), sizeof pki_ssl->ssl_name);
				dict_set(conf->sc_ssl_dict, pki_ssl->ssl_name, pki_ssl);
			}
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 619 "../../smtpd/parse.y"
    {
			char *p, *backend, *config;

			p = (yyvsp[(3) - (3)].v.string);
			if (*p == '/') {
				backend = "static";
				config = (yyvsp[(3) - (3)].v.string);
			}
			else {
				backend = (yyvsp[(3) - (3)].v.string);
				config = NULL;
				for (p = (yyvsp[(3) - (3)].v.string); *p && *p != ':'; p++)
					;
				if (*p == ':') {
					*p = '\0';
					backend = (yyvsp[(3) - (3)].v.string);
					config  = p+1;
				}
			}
			if (config != NULL && *config != '/') {
				yyerror("invalid backend parameter for table: %s",
				    (yyvsp[(2) - (3)].v.string));
				free((yyvsp[(2) - (3)].v.string));
				free((yyvsp[(3) - (3)].v.string));
				YYERROR;
			}
			table = table_create(backend, (yyvsp[(2) - (3)].v.string), NULL, config);
			if (!table_config(table)) {
				yyerror("invalid backend configuration for table %s",
				    table->t_name);
				free((yyvsp[(2) - (3)].v.string));
				free((yyvsp[(3) - (3)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (3)].v.string));
			free((yyvsp[(3) - (3)].v.string));
		}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 656 "../../smtpd/parse.y"
    {
			table = table_create("static", (yyvsp[(2) - (2)].v.string), NULL, NULL);
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 659 "../../smtpd/parse.y"
    {
			table = NULL;
		}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 666 "../../smtpd/parse.y"
    {
			table->t_type = T_HASH;
			table_add(table, (yyvsp[(1) - (3)].v.string), (yyvsp[(3) - (3)].v.string));
			free((yyvsp[(1) - (3)].v.string));
			free((yyvsp[(3) - (3)].v.string));
		}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 678 "../../smtpd/parse.y"
    {
			table->t_type = T_LIST;
			table_add(table, (yyvsp[(1) - (1)].v.string), NULL);
			free((yyvsp[(1) - (1)].v.string));
		}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 689 "../../smtpd/parse.y"
    { }
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 690 "../../smtpd/parse.y"
    { }
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 693 "../../smtpd/parse.y"
    {
			struct table	*t;

			t = table_create("static", NULL, NULL, NULL);
			t->t_type = T_LIST;
			table_add(t, (yyvsp[(1) - (1)].v.string), NULL);
			free((yyvsp[(1) - (1)].v.string));
			(yyval.v.table) = t;
		}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 702 "../../smtpd/parse.y"
    {
			table = table_create("static", NULL, NULL, NULL);
		}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 704 "../../smtpd/parse.y"
    {
			(yyval.v.table) = table;
		}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 709 "../../smtpd/parse.y"
    {
			struct table	*t;

			if ((t = table_find((yyvsp[(2) - (3)].v.string), NULL)) == NULL) {
				yyerror("no such table: %s", (yyvsp[(2) - (3)].v.string));
				free((yyvsp[(2) - (3)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (3)].v.string));
			(yyval.v.table) = t;
		}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 722 "../../smtpd/parse.y"
    { (yyval.v.table) = (yyvsp[(1) - (1)].v.table); }
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 723 "../../smtpd/parse.y"
    { (yyval.v.table) = (yyvsp[(1) - (1)].v.table); }
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 726 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(2) - (2)].v.table);

			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
				yyerror("invalid use of table \"%s\" as ALIAS parameter",
				    t->t_name);
				YYERROR;
			}

			(yyval.v.table) = t;
		}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 739 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(2) - (2)].v.table);

			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_ALIAS)) {
				yyerror("invalid use of table \"%s\" as VIRTUAL parameter",
				    t->t_name);
				YYERROR;
			}
			(yyval.v.table) = t;
		}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 751 "../../smtpd/parse.y"
    {
			if (rule->r_mapping) {
				yyerror("alias specified multiple times");
				YYERROR;
			}
			rule->r_desttype = DEST_DOM;
			rule->r_mapping = (yyvsp[(1) - (1)].v.table);
		}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 759 "../../smtpd/parse.y"
    {
			if (rule->r_mapping) {
				yyerror("virtual specified multiple times");
				YYERROR;
			}
			rule->r_desttype = DEST_VDOM;
			rule->r_mapping = (yyvsp[(1) - (1)].v.table);
		}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 769 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(2) - (2)].v.table);

			if (rule->r_userbase) {
				yyerror("userbase specified multiple times");
				YYERROR;
			}
			if (! table_check_use(t, T_DYNAMIC|T_HASH, K_USERINFO)) {
				yyerror("invalid use of table \"%s\" as USERBASE parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_userbase = t;
		}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 785 "../../smtpd/parse.y"
    {
			rule->r_action = A_MAILDIR;
			if (strlcpy(rule->r_value.buffer, "~/Maildir",
			    sizeof(rule->r_value.buffer)) >=
			    sizeof(rule->r_value.buffer))
				fatal("pathname too long");
		}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 792 "../../smtpd/parse.y"
    {
			rule->r_action = A_MAILDIR;
			if (strlcpy(rule->r_value.buffer, (yyvsp[(4) - (4)].v.string),
			    sizeof(rule->r_value.buffer)) >=
			    sizeof(rule->r_value.buffer))
				fatal("pathname too long");
			free((yyvsp[(4) - (4)].v.string));
		}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 800 "../../smtpd/parse.y"
    {
			rule->r_action = A_LMTP;
			if (strchr((yyvsp[(4) - (4)].v.string), ':') || (yyvsp[(4) - (4)].v.string)[0] == '/') {
				if (strlcpy(rule->r_value.buffer, (yyvsp[(4) - (4)].v.string),
					sizeof(rule->r_value.buffer))
					>= sizeof(rule->r_value.buffer))
					fatal("lmtp destination too long");
			} else
				fatal("invalid lmtp destination");
			free((yyvsp[(4) - (4)].v.string));
		}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 811 "../../smtpd/parse.y"
    {
			rule->r_action = A_MBOX;
			if (strlcpy(rule->r_value.buffer, _PATH_MAILDIR "/%u",
			    sizeof(rule->r_value.buffer))
			    >= sizeof(rule->r_value.buffer))
				fatal("pathname too long");
		}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 818 "../../smtpd/parse.y"
    {
			rule->r_action = A_MDA;
			if (strlcpy(rule->r_value.buffer, (yyvsp[(4) - (4)].v.string),
			    sizeof(rule->r_value.buffer))
			    >= sizeof(rule->r_value.buffer))
				fatal("command too long");
			free((yyvsp[(4) - (4)].v.string));
		}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 828 "../../smtpd/parse.y"
    {
			rule->r_action = A_RELAY;
		}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 831 "../../smtpd/parse.y"
    {
			rule->r_action = A_RELAYVIA;
			if (! text_to_relayhost(&rule->r_value.relayhost, (yyvsp[(3) - (3)].v.string))) {
				yyerror("error: invalid url: %s", (yyvsp[(3) - (3)].v.string));
				free((yyvsp[(3) - (3)].v.string));
				YYERROR;
			}
			free((yyvsp[(3) - (3)].v.string));
		}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 839 "../../smtpd/parse.y"
    {
			/* no worries, F_AUTH cant be set without SSL */
			if (rule->r_value.relayhost.flags & F_AUTH) {
				if (rule->r_value.relayhost.authtable[0] == '\0') {
					yyerror("error: auth without auth table");
					YYERROR;
				}
			}
		}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 850 "../../smtpd/parse.y"
    { (yyval.v.number) = 1; }
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 851 "../../smtpd/parse.y"
    { (yyval.v.number) = 0; }
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 854 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(4) - (4)].v.table);

			if (rule->r_sources) {
				yyerror("from specified multiple times");
				YYERROR;
			}
			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_NETADDR)) {
				yyerror("invalid use of table \"%s\" as FROM parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notsources = (yyvsp[(2) - (4)].v.number);
			rule->r_sources = t;
		}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 869 "../../smtpd/parse.y"
    {
			if (rule->r_sources) {
				yyerror("from specified multiple times");
				YYERROR;
			}
			rule->r_sources = table_find("<anyhost>", NULL);
			rule->r_notsources = (yyvsp[(2) - (3)].v.number);
		}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 877 "../../smtpd/parse.y"
    {
			if (rule->r_sources) {
				yyerror("from specified multiple times");
				YYERROR;
			}
			rule->r_sources = table_find("<localhost>", NULL);
			rule->r_notsources = (yyvsp[(2) - (3)].v.number);
		}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 887 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(4) - (4)].v.table);

			if (rule->r_destination) {
				yyerror("for specified multiple times");
				YYERROR;
			}
			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_DOMAIN)) {
				yyerror("invalid use of table \"%s\" as DOMAIN parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notdestination = (yyvsp[(2) - (4)].v.number);
			rule->r_destination = t;
		}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 902 "../../smtpd/parse.y"
    {
			if (rule->r_destination) {
				yyerror("for specified multiple times");
				YYERROR;
			}
			rule->r_notdestination = (yyvsp[(2) - (3)].v.number);
			rule->r_destination = table_find("<anydestination>", NULL);
		}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 910 "../../smtpd/parse.y"
    {
			if (rule->r_destination) {
				yyerror("for specified multiple times");
				YYERROR;
			}
			rule->r_notdestination = (yyvsp[(2) - (3)].v.number);
			rule->r_destination = table_find("<localnames>", NULL);
		}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 920 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(3) - (3)].v.table);

			if (rule->r_senders) {
				yyerror("sender specified multiple times");
				YYERROR;
			}

			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
				yyerror("invalid use of table \"%s\" as SENDER parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notsenders = (yyvsp[(2) - (3)].v.number);
			rule->r_senders = t;
		}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 938 "../../smtpd/parse.y"
    {
			struct table   *t = (yyvsp[(3) - (3)].v.table);

			if (rule->r_recipients) {
				yyerror("recipient specified multiple times");
				YYERROR;
			}

			if (! table_check_use(t, T_DYNAMIC|T_LIST, K_MAILADDR)) {
				yyerror("invalid use of table \"%s\" as RECIPIENT parameter",
				    t->t_name);
				YYERROR;
			}
			rule->r_notrecipients = (yyvsp[(2) - (3)].v.number);
			rule->r_recipients = t;
		}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 956 "../../smtpd/parse.y"
    {
			if (rule->r_forwardonly) {
				yyerror("forward-only specified multiple times");
				YYERROR;
			}
			rule->r_forwardonly = 1;
		}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 965 "../../smtpd/parse.y"
    {
			if (rule->r_qexpire != -1) {
				yyerror("expire specified multiple times");
				YYERROR;
			}
			rule->r_qexpire = delaytonum((yyvsp[(2) - (2)].v.string));
			if (rule->r_qexpire == -1) {
				yyerror("invalid expire delay: %s", (yyvsp[(2) - (2)].v.string));
				free((yyvsp[(2) - (2)].v.string));
				YYERROR;
			}
			free((yyvsp[(2) - (2)].v.string));
		}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1010 "../../smtpd/parse.y"
    {
			rule = xcalloc(1, sizeof(*rule), "parse rule: ACCEPT");
			rule->r_action = A_NONE;
			rule->r_decision = R_ACCEPT;
			rule->r_desttype = DEST_DOM;
			rule->r_qexpire = -1;
		}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1016 "../../smtpd/parse.y"
    {
			if (! rule->r_sources)
				rule->r_sources = table_find("<localhost>", NULL);			
			if (! rule->r_destination)
			 	rule->r_destination = table_find("<localnames>", NULL);
			if (! rule->r_userbase)
				rule->r_userbase = table_find("<getpwnam>", NULL);
			if (rule->r_qexpire == -1)
				rule->r_qexpire = conf->sc_qexpire;
			if (rule->r_action == A_RELAY || rule->r_action == A_RELAYVIA) {
				if (rule->r_userbase != table_find("<getpwnam>", NULL)) {
					yyerror("userbase may not be used with a relay rule");
					YYERROR;
				}
				if (rule->r_mapping) {
					yyerror("aliases/virtual may not be used with a relay rule");
					YYERROR;
				}
			}
			if (rule->r_forwardonly && rule->r_action != A_NONE) {
				yyerror("forward-only may not be used with a default action");
				YYERROR;
			}
			TAILQ_INSERT_TAIL(conf->sc_rules, rule, r_entry);
			rule = NULL;
		}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1042 "../../smtpd/parse.y"
    {
			rule = xcalloc(1, sizeof(*rule), "parse rule: REJECT");
			rule->r_decision = R_REJECT;
			rule->r_desttype = DEST_DOM;
		}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1046 "../../smtpd/parse.y"
    {
			if (! rule->r_sources)
				rule->r_sources = table_find("<localhost>", NULL);
			if (! rule->r_destination)
				rule->r_destination = table_find("<localnames>", NULL);
			TAILQ_INSERT_TAIL(conf->sc_rules, rule, r_entry);
			rule = NULL;
		}
    break;



/* Line 1455 of yacc.c  */
#line 3151 "parse.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1055 "../../smtpd/parse.y"


struct keywords {
	const char	*k_name;
	int		 k_val;
};

int
yyerror(const char *fmt, ...)
{
	va_list		 ap;
	char		*nfmt;

	file->errors++;
	va_start(ap, fmt);
	if (asprintf(&nfmt, "%s:%d: %s", file->name, yylval.lineno, fmt) == -1)
		fatalx("yyerror asprintf");
	vlog(LOG_CRIT, nfmt, ap);
	va_end(ap);
	free(nfmt);
	return (0);
}

int
kw_cmp(const void *k, const void *e)
{
	return (strcmp(k, ((const struct keywords *)e)->k_name));
}

int
lookup(char *s)
{
	/* this has to be sorted always */
	static const struct keywords keywords[] = {
		{ "accept",		ACCEPT },
		{ "alias",		ALIAS },
		{ "any",		ANY },
		{ "as",			AS },
		{ "auth",		AUTH },
		{ "auth-optional",     	AUTH_OPTIONAL },
		{ "backup",		BACKUP },
		{ "bounce-warn",	BOUNCEWARN },
		{ "ca",			CA },
		{ "certificate",	CERTIFICATE },
		{ "compression",	COMPRESSION },
		{ "deliver",		DELIVER },
		{ "dhparams",		DHPARAMS },
		{ "domain",		DOMAIN },
		{ "encryption",		ENCRYPTION },
		{ "expire",		EXPIRE },
		{ "filter",		FILTER },
		{ "for",		FOR },
		{ "forward-only",      	FORWARDONLY },
		{ "from",		FROM },
		{ "hostname",		HOSTNAME },
		{ "hostnames",		HOSTNAMES },
		{ "include",		INCLUDE },
		{ "inet4",		INET4 },
		{ "inet6",		INET6 },
		{ "key",		KEY },
		{ "limit",		LIMIT },
		{ "listen",		LISTEN },
		{ "lmtp",		LMTP },
		{ "local",		LOCAL },
		{ "maildir",		MAILDIR },
		{ "mask-source",	MASK_SOURCE },
		{ "max-message-size",  	MAXMESSAGESIZE },
		{ "max-mta-deferred",  	MAXMTADEFERRED },
		{ "max-scheduler-inflight",  	MAXSCHEDULERINFLIGHT },
		{ "mbox",		MBOX },
		{ "mda",		MDA },
		{ "mta",		MTA },
		{ "on",			ON },
		{ "pki",		PKI },
		{ "port",		PORT },
		{ "queue",		QUEUE },
		{ "recipient",		RECIPIENT },
		{ "reject",		REJECT },
		{ "relay",		RELAY },
		{ "secure",		SECURE },
		{ "sender",    		SENDER },
		{ "smtps",		SMTPS },
		{ "source",		SOURCE },
		{ "table",		TABLE },
		{ "tag",		TAG },
		{ "tagged",		TAGGED },
		{ "tls",		TLS },
		{ "tls-require",       	TLS_REQUIRE },
		{ "to",			TO },
		{ "userbase",		USERBASE },
		{ "verify",		VERIFY },
		{ "via",		VIA },
		{ "virtual",		VIRTUAL },
	};
	const struct keywords	*p;

	p = bsearch(s, keywords, sizeof(keywords)/sizeof(keywords[0]),
	    sizeof(keywords[0]), kw_cmp);

	if (p)
		return (p->k_val);
	else
		return (STRING);
}

#define MAXPUSHBACK	128

char	*parsebuf;
int	 parseindex;
char	 pushback_buffer[MAXPUSHBACK];
int	 pushback_index = 0;

int
lgetc(int quotec)
{
	int		c, next;

	if (parsebuf) {
		/* Read character from the parsebuffer instead of input. */
		if (parseindex >= 0) {
			c = parsebuf[parseindex++];
			if (c != '\0')
				return (c);
			parsebuf = NULL;
		} else
			parseindex++;
	}

	if (pushback_index)
		return (pushback_buffer[--pushback_index]);

	if (quotec) {
		if ((c = getc(file->stream)) == EOF) {
			yyerror("reached end of file while parsing "
			    "quoted string");
			if (file == topfile || popfile() == EOF)
				return (EOF);
			return (quotec);
		}
		return (c);
	}

	while ((c = getc(file->stream)) == '\\') {
		next = getc(file->stream);
		if (next != '\n') {
			c = next;
			break;
		}
		yylval.lineno = file->lineno;
		file->lineno++;
	}

	while (c == EOF) {
		if (file == topfile || popfile() == EOF)
			return (EOF);
		c = getc(file->stream);
	}
	return (c);
}

int
lungetc(int c)
{
	if (c == EOF)
		return (EOF);
	if (parsebuf) {
		parseindex--;
		if (parseindex >= 0)
			return (c);
	}
	if (pushback_index < MAXPUSHBACK-1)
		return (pushback_buffer[pushback_index++] = c);
	else
		return (EOF);
}

int
findeol(void)
{
	int	c;

	parsebuf = NULL;
	pushback_index = 0;

	/* skip to either EOF or the first real EOL */
	while (1) {
		c = lgetc(0);
		if (c == '\n') {
			file->lineno++;
			break;
		}
		if (c == EOF)
			break;
	}
	return (ERROR);
}

int
yylex(void)
{
	char	 buf[8096];
	char	*p, *val;
	int	 quotec, next, c;
	int	 token;

top:
	p = buf;
	while ((c = lgetc(0)) == ' ' || c == '\t')
		; /* nothing */

	yylval.lineno = file->lineno;
	if (c == '#')
		while ((c = lgetc(0)) != '\n' && c != EOF)
			; /* nothing */
	if (c == '$' && parsebuf == NULL) {
		while (1) {
			if ((c = lgetc(0)) == EOF)
				return (0);

			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			if (isalnum(c) || c == '_') {
				*p++ = (char)c;
				continue;
			}
			*p = '\0';
			lungetc(c);
			break;
		}
		val = symget(buf);
		if (val == NULL) {
			yyerror("macro '%s' not defined", buf);
			return (findeol());
		}
		parsebuf = val;
		parseindex = 0;
		goto top;
	}

	switch (c) {
	case '\'':
	case '"':
		quotec = c;
		while (1) {
			if ((c = lgetc(quotec)) == EOF)
				return (0);
			if (c == '\n') {
				file->lineno++;
				continue;
			} else if (c == '\\') {
				if ((next = lgetc(quotec)) == EOF)
					return (0);
				if (next == quotec || c == ' ' || c == '\t')
					c = next;
				else if (next == '\n') {
					file->lineno++;
					continue;
				} else
					lungetc(next);
			} else if (c == quotec) {
				*p = '\0';
				break;
			}
			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			*p++ = (char)c;
		}
		yylval.v.string = strdup(buf);
		if (yylval.v.string == NULL)
			err(1, "yylex: strdup");
		return (STRING);
	}

#define allowed_to_end_number(x) \
	(isspace(x) || x == ')' || x ==',' || x == '/' || x == '}' || x == '=')

	if (c == '-' || isdigit(c)) {
		do {
			*p++ = c;
			if ((unsigned)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && isdigit(c));
		lungetc(c);
		if (p == buf + 1 && buf[0] == '-')
			goto nodigits;
		if (c == EOF || allowed_to_end_number(c)) {
			const char *errstr = NULL;

			*p = '\0';
			yylval.v.number = strtonum(buf, LLONG_MIN,
			    LLONG_MAX, &errstr);
			if (errstr) {
				yyerror("\"%s\" invalid number: %s",
				    buf, errstr);
				return (findeol());
			}
			return (NUMBER);
		} else {
nodigits:
			while (p > buf + 1)
				lungetc(*--p);
			c = *--p;
			if (c == '-')
				return (c);
		}
	}

	if (c == '=') {
		if ((c = lgetc(0)) != EOF && c == '>')
			return (ARROW);
		lungetc(c);
		c = '=';
	}

#define allowed_in_string(x) \
	(isalnum(x) || (ispunct(x) && x != '(' && x != ')' && \
	x != '{' && x != '}' && x != '<' && x != '>' && \
	x != '!' && x != '=' && x != '#' && \
	x != ','))

	if (isalnum(c) || c == ':' || c == '_') {
		do {
			*p++ = c;
			if ((unsigned)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && (allowed_in_string(c)));
		lungetc(c);
		*p = '\0';
		if ((token = lookup(buf)) == STRING)
			if ((yylval.v.string = strdup(buf)) == NULL)
				err(1, "yylex: strdup");
		return (token);
	}
	if (c == '\n') {
		yylval.lineno = file->lineno;
		file->lineno++;
	}
	if (c == EOF)
		return (0);
	return (c);
}

int
check_file_secrecy(int fd, const char *fname)
{
	struct stat	st;

	if (fstat(fd, &st)) {
		log_warn("warn: cannot stat %s", fname);
		return (-1);
	}
	if (st.st_uid != 0 && st.st_uid != getuid()) {
		log_warnx("warn: %s: owner not root or current user", fname);
		return (-1);
	}
	if (st.st_mode & (S_IRWXG | S_IRWXO)) {
		log_warnx("warn: %s: group/world readable/writeable", fname);
		return (-1);
	}
	return (0);
}

struct file *
pushfile(const char *name, int secret)
{
	struct file	*nfile;

	if ((nfile = calloc(1, sizeof(struct file))) == NULL) {
		log_warn("warn: malloc");
		return (NULL);
	}
	if ((nfile->name = strdup(name)) == NULL) {
		log_warn("warn: malloc");
		free(nfile);
		return (NULL);
	}
	if ((nfile->stream = fopen(nfile->name, "r")) == NULL) {
		log_warn("warn: %s", nfile->name);
		free(nfile->name);
		free(nfile);
		return (NULL);
	} else if (secret &&
	    check_file_secrecy(fileno(nfile->stream), nfile->name)) {
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	nfile->lineno = 1;
	TAILQ_INSERT_TAIL(&files, nfile, entry);
	return (nfile);
}

int
popfile(void)
{
	struct file	*prev;

	if ((prev = TAILQ_PREV(file, files, entry)) != NULL)
		prev->errors += file->errors;

	TAILQ_REMOVE(&files, file, entry);
	fclose(file->stream);
	free(file->name);
	free(file);
	file = prev;
	return (file ? 0 : EOF);
}

int
parse_config(struct smtpd *x_conf, const char *filename, int opts)
{
	struct sym     *sym, *next;
	struct table   *t;
	char		hostname[SMTPD_MAXHOSTNAMELEN];
	char		hostname_copy[SMTPD_MAXHOSTNAMELEN];

	if (! getmailname(hostname, sizeof hostname))
		return (-1);

	conf = x_conf;
	bzero(conf, sizeof(*conf));

	strlcpy(conf->sc_hostname, hostname, sizeof(conf->sc_hostname));

	conf->sc_maxsize = DEFAULT_MAX_BODY_SIZE;

	conf->sc_tables_dict = calloc(1, sizeof(*conf->sc_tables_dict));
	conf->sc_rules = calloc(1, sizeof(*conf->sc_rules));
	conf->sc_listeners = calloc(1, sizeof(*conf->sc_listeners));
	conf->sc_ssl_dict = calloc(1, sizeof(*conf->sc_ssl_dict));
	conf->sc_limits_dict = calloc(1, sizeof(*conf->sc_limits_dict));

	/* Report mails delayed for more than 4 hours */
	conf->sc_bounce_warn[0] = 3600 * 4;

	if (conf->sc_tables_dict == NULL	||
	    conf->sc_rules == NULL		||
	    conf->sc_listeners == NULL		||
	    conf->sc_ssl_dict == NULL		||
	    conf->sc_limits_dict == NULL) {
		log_warn("warn: cannot allocate memory");
		free(conf->sc_tables_dict);
		free(conf->sc_rules);
		free(conf->sc_listeners);
		free(conf->sc_ssl_dict);
		free(conf->sc_limits_dict);
		return (-1);
	}

	errors = 0;

	table = NULL;
	rule = NULL;

	dict_init(&conf->sc_filters);

	dict_init(conf->sc_ssl_dict);
	dict_init(conf->sc_tables_dict);

	dict_init(conf->sc_limits_dict);
	limits = xcalloc(1, sizeof(*limits), "mta_limits");
	limit_mta_set_defaults(limits);
	dict_xset(conf->sc_limits_dict, "default", limits);

	TAILQ_INIT(conf->sc_listeners);
	TAILQ_INIT(conf->sc_rules);

	conf->sc_qexpire = SMTPD_QUEUE_EXPIRY;
	conf->sc_opts = opts;

	conf->sc_mta_max_deferred = 100;
	conf->sc_scheduler_max_inflight = 5000;

	if ((file = pushfile(filename, 0)) == NULL) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}
	topfile = file;

	/*
	 * declare special "localhost", "anyhost" and "localnames" tables
	 */
	set_localaddrs();

	t = table_create("static", "<localnames>", NULL, NULL);
	t->t_type = T_LIST;
	table_add(t, "localhost", NULL);
	table_add(t, hostname, NULL);

	t = table_create("static", "<anydestination>", NULL, NULL);
	t->t_type = T_LIST;
	table_add(t, "*", NULL);

	/* can't truncate here */
	(void)strlcpy(hostname_copy, hostname, sizeof hostname_copy);

	hostname_copy[strcspn(hostname_copy, ".")] = '\0';
	if (strcmp(hostname, hostname_copy) != 0)
		table_add(t, hostname_copy, NULL);

	table_create("getpwnam", "<getpwnam>", NULL, NULL);

	/*
	 * parse configuration
	 */
	setservent(1);
	yyparse();
	errors = file->errors;
	popfile();
	endservent();

	/* Free macros and check which have not been used. */
	for (sym = TAILQ_FIRST(&symhead); sym != NULL; sym = next) {
		next = TAILQ_NEXT(sym, entry);
		if ((conf->sc_opts & SMTPD_OPT_VERBOSE) && !sym->used)
			fprintf(stderr, "warning: macro '%s' not "
			    "used\n", sym->nam);
		if (!sym->persist) {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}

	if (TAILQ_EMPTY(conf->sc_rules)) {
		log_warnx("warn: no rules, nothing to do");
		errors++;
	}

	if (errors) {
		purge_config(PURGE_EVERYTHING);
		return (-1);
	}

	return (0);
}

int
symset(const char *nam, const char *val, int persist)
{
	struct sym	*sym;

	for (sym = TAILQ_FIRST(&symhead); sym && strcmp(nam, sym->nam);
	    sym = TAILQ_NEXT(sym, entry))
		;	/* nothing */

	if (sym != NULL) {
		if (sym->persist == 1)
			return (0);
		else {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}
	if ((sym = calloc(1, sizeof(*sym))) == NULL)
		return (-1);

	sym->nam = strdup(nam);
	if (sym->nam == NULL) {
		free(sym);
		return (-1);
	}
	sym->val = strdup(val);
	if (sym->val == NULL) {
		free(sym->nam);
		free(sym);
		return (-1);
	}
	sym->used = 0;
	sym->persist = persist;
	TAILQ_INSERT_TAIL(&symhead, sym, entry);
	return (0);
}

int
cmdline_symset(char *s)
{
	char	*sym, *val;
	int	ret;
	size_t	len;

	if ((val = strrchr(s, '=')) == NULL)
		return (-1);

	len = strlen(s) - strlen(val) + 1;
	if ((sym = malloc(len)) == NULL)
		errx(1, "cmdline_symset: malloc");

	(void)strlcpy(sym, s, len);

	ret = symset(sym, val + 1, 1);
	free(sym);

	return (ret);
}

char *
symget(const char *nam)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry)
		if (strcmp(nam, sym->nam) == 0) {
			sym->used = 1;
			return (sym->val);
		}
	return (NULL);
}

static void
create_listener(struct listenerlist *ll,  struct listen_opts *lo)
{
	uint16_t	flags;

	if (lo->port != 0 && lo->ssl == F_SSL)
		errx(1, "invalid listen option: tls/smtps on same port");
	
	if (lo->auth != 0 && !lo->ssl)
		errx(1, "invalid listen option: auth requires tls/smtps");
	
	if (lo->pki && !lo->ssl)
		errx(1, "invalid listen option: pki requires tls/smtps");
	
	if (lo->ssl && !lo->pki)
		errx(1, "invalid listen option: tls/smtps requires pki");

	flags = lo->flags;


	if (lo->port) {
		lo->flags = lo->ssl|lo->auth|flags;
		lo->port = htons(lo->port);
		if (! interface(ll, lo))
			if (host(ll, lo) <= 0)
				errx(1, "invalid virtual ip or interface: %s", lo->ifx);
	}
	else {
		if (lo->ssl & F_SMTPS) {
			lo->port = htons(465);
			lo->flags = F_SMTPS|lo->auth|flags;
			if (! interface(ll, lo))
				if (host(ll, lo) <= 0)
					errx(1, "invalid virtual ip or interface: %s", lo->ifx);
		}

		if (! lo->ssl || (lo->ssl & F_STARTTLS)) {
			lo->port = htons(25);
			lo->flags = lo->auth|flags;
			if (lo->ssl & F_STARTTLS)
				lo->flags |= F_STARTTLS;
			if (! interface(ll, lo))
				if (host(ll, lo) <= 0)
					errx(1, "invalid virtual ip or interface: %s", lo->ifx);
		}
	}
}

static void
config_listener(struct listener *h,  struct listen_opts *lo)
{
	h->fd = -1;
	h->port = lo->port;
	h->flags = lo->flags;

	if (lo->hostname == NULL)
		lo->hostname = conf->sc_hostname;

	h->ssl = NULL;
	h->ssl_cert_name[0] = '\0';

	if (lo->authtable != NULL)
		(void)strlcpy(h->authtable, lo->authtable, sizeof(h->authtable));
	if (lo->pki != NULL)
		(void)strlcpy(h->ssl_cert_name, lo->pki, sizeof(h->ssl_cert_name));
	if (lo->tag != NULL)
		(void)strlcpy(h->tag, lo->tag, sizeof(h->tag));

	(void)strlcpy(h->hostname, lo->hostname, sizeof(h->hostname));
	if (lo->hostnametable)
		(void)strlcpy(h->hostnametable, lo->hostnametable->t_name, sizeof(h->hostnametable));
}

struct listener *
host_v4(const char *s, in_port_t port)
{
	struct in_addr		 ina;
	struct sockaddr_in	*sain;
	struct listener		*h;

	bzero(&ina, sizeof(ina));
	if (inet_pton(AF_INET, s, &ina) != 1)
		return (NULL);

	h = xcalloc(1, sizeof(*h), "host_v4");
	sain = (struct sockaddr_in *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
	sain->sin_len = sizeof(struct sockaddr_in);
#endif
	sain->sin_family = AF_INET;
	sain->sin_addr.s_addr = ina.s_addr;
	sain->sin_port = port;

	return (h);
}

struct listener *
host_v6(const char *s, in_port_t port)
{
	struct in6_addr		 ina6;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	bzero(&ina6, sizeof(ina6));
	if (inet_pton(AF_INET6, s, &ina6) != 1)
		return (NULL);

	h = xcalloc(1, sizeof(*h), "host_v6");
	sin6 = (struct sockaddr_in6 *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
	sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
	sin6->sin6_family = AF_INET6;
	sin6->sin6_port = port;
	memcpy(&sin6->sin6_addr, &ina6, sizeof(ina6));

	return (h);
}

int
host_dns(struct listenerlist *al, struct listen_opts *lo)
{
	struct addrinfo		 hints, *res0, *res;
	int			 error, cnt = 0;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;

	bzero(&hints, sizeof(hints));
	hints.ai_family = PF_UNSPEC;
	hints.ai_socktype = SOCK_DGRAM; /* DUMMY */
	error = getaddrinfo(lo->ifx, NULL, &hints, &res0);
	if (error == EAI_AGAIN || error == EAI_NODATA || error == EAI_NONAME)
		return (0);
	if (error) {
		log_warnx("warn: host_dns: could not parse \"%s\": %s", lo->ifx,
		    gai_strerror(error));
		return (-1);
	}

	for (res = res0; res; res = res->ai_next) {
		if (res->ai_family != AF_INET &&
		    res->ai_family != AF_INET6)
			continue;
		h = xcalloc(1, sizeof(*h), "host_dns");

		h->ss.ss_family = res->ai_family;
		if (res->ai_family == AF_INET) {
			sain = (struct sockaddr_in *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			sain->sin_addr.s_addr = ((struct sockaddr_in *)
			    res->ai_addr)->sin_addr.s_addr;
			sain->sin_port = lo->port;
		} else {
			sin6 = (struct sockaddr_in6 *)&h->ss;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			memcpy(&sin6->sin6_addr, &((struct sockaddr_in6 *)
			    res->ai_addr)->sin6_addr, sizeof(struct in6_addr));
			sin6->sin6_port = lo->port;
		}

		config_listener(h, lo);

		TAILQ_INSERT_HEAD(al, h, entry);
		cnt++;
	}

	freeaddrinfo(res0);
	return (cnt);
}

int
host(struct listenerlist *al, struct listen_opts *lo)
{
	struct listener *h;

	h = host_v4(lo->ifx, lo->port);

	/* IPv6 address? */
	if (h == NULL)
		h = host_v6(lo->ifx, lo->port);

	if (h != NULL) {
		config_listener(h, lo);
		TAILQ_INSERT_HEAD(al, h, entry);
		return (1);
	}

	return (host_dns(al, lo));
}

int
interface(struct listenerlist *al, struct listen_opts *lo)
{
	struct ifaddrs *ifap, *p;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct listener		*h;
	int			ret = 0;

	if (getifaddrs(&ifap) == -1)
		fatal("getifaddrs");

	for (p = ifap; p != NULL; p = p->ifa_next) {
		if (p->ifa_addr == NULL)
			continue;
		if (strcmp(p->ifa_name, lo->ifx) != 0 &&
		    ! is_if_in_group(p->ifa_name, lo->ifx))
			continue;
		if (lo->family != AF_UNSPEC && lo->family != p->ifa_addr->sa_family)
			continue;

		h = xcalloc(1, sizeof(*h), "interface");

		switch (p->ifa_addr->sa_family) {
		case AF_INET:
			sain = (struct sockaddr_in *)&h->ss;
			*sain = *(struct sockaddr_in *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			sain->sin_port = lo->port;
			break;

		case AF_INET6:
			sin6 = (struct sockaddr_in6 *)&h->ss;
			*sin6 = *(struct sockaddr_in6 *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			sin6->sin6_port = lo->port;
			break;

		default:
			free(h);
			continue;
		}

		config_listener(h, lo);
		ret = 1;
		TAILQ_INSERT_HEAD(al, h, entry);
	}

	freeifaddrs(ifap);

	return ret;
}

void
set_localaddrs(void)
{
	struct ifaddrs *ifap, *p;
	struct sockaddr_storage ss;
	struct sockaddr_in	*sain;
	struct sockaddr_in6	*sin6;
	struct table		*t;

	t = table_create("static", "<anyhost>", NULL, NULL);
	table_add(t, "local", NULL);
	table_add(t, "0.0.0.0/0", NULL);
	table_add(t, "::/0", NULL);

	if (getifaddrs(&ifap) == -1)
		fatal("getifaddrs");

	t = table_create("static", "<localhost>", NULL, NULL);
	table_add(t, "local", NULL);

	for (p = ifap; p != NULL; p = p->ifa_next) {
		if (p->ifa_addr == NULL)
			continue;
		switch (p->ifa_addr->sa_family) {
		case AF_INET:
			sain = (struct sockaddr_in *)&ss;
			*sain = *(struct sockaddr_in *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN_SIN_LEN
			sain->sin_len = sizeof(struct sockaddr_in);
#endif
			table_add(t, ss_to_text(&ss), NULL);
			break;

		case AF_INET6:
			sin6 = (struct sockaddr_in6 *)&ss;
			*sin6 = *(struct sockaddr_in6 *)p->ifa_addr;
#ifdef HAVE_STRUCT_SOCKADDR_IN6_SIN6_LEN
			sin6->sin6_len = sizeof(struct sockaddr_in6);
#endif
			table_add(t, ss_to_text(&ss), NULL);
			break;
		}
	}

	freeifaddrs(ifap);
}

int
delaytonum(char *str)
{
	unsigned int     factor;
	size_t           len;
	const char      *errstr = NULL;
	int              delay;
  	
	/* we need at least 1 digit and 1 unit */
	len = strlen(str);
	if (len < 2)
		goto bad;
	
	switch(str[len - 1]) {
		
	case 's':
		factor = 1;
		break;
		
	case 'm':
		factor = 60;
		break;
		
	case 'h':
		factor = 60 * 60;
		break;
		
	case 'd':
		factor = 24 * 60 * 60;
		break;
		
	default:
		goto bad;
	}
  	
	str[len - 1] = '\0';
	delay = strtonum(str, 1, INT_MAX / factor, &errstr);
	if (errstr)
		goto bad;
	
	return (delay * factor);
  	
bad:
	return (-1);
}

int
is_if_in_group(const char *ifname, const char *groupname)
{
#ifdef HAVE_STRUCT_IFGROUPREQ
        unsigned int		 len;
        struct ifgroupreq        ifgr;
        struct ifg_req          *ifg;
	int			 s;
	int			 ret = 0;

	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
		err(1, "socket");

        memset(&ifgr, 0, sizeof(ifgr));
        strlcpy(ifgr.ifgr_name, ifname, IFNAMSIZ);
        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1) {
                if (errno == EINVAL || errno == ENOTTY)
			goto end;
		err(1, "SIOCGIFGROUP");
        }

        len = ifgr.ifgr_len;
        ifgr.ifgr_groups =
            (struct ifg_req *)xcalloc(len/sizeof(struct ifg_req),
		sizeof(struct ifg_req), "is_if_in_group");
        if (ioctl(s, SIOCGIFGROUP, (caddr_t)&ifgr) == -1)
                err(1, "SIOCGIFGROUP");
	
        ifg = ifgr.ifgr_groups;
        for (; ifg && len >= sizeof(struct ifg_req); ifg++) {
                len -= sizeof(struct ifg_req);
		if (strcmp(ifg->ifgrq_group, groupname) == 0) {
			ret = 1;
			break;
		}
        }
        free(ifgr.ifgr_groups);

end:
	close(s);
	return ret;
#else
	return (0);
#endif
}

